#ifndef DF_H
#define DF_H

#include <QtGui/QWidget>
#include <QList>
#include "ui_form.h"

class df : public QWidget
{
    Q_OBJECT

public:
    df(QWidget *parent = 0, Qt::WFlags flags = 0);
    ~df();
    
	
private:
	Ui::Form ui;
        QString path;
	QList<QTextCodec *> codecs;
	int ID_WARE;
	QString current, prev;
	char ch;
        int current_column;
        QString save_path;
        QStringList list_groups;
        QStringList list_wares;
        
        void setCodecList();
        void add_group(const QString& str, const QString& ware="");
	// find item and remove him
        QTreeWidgetItem* find_item(const QString& name, bool b_absolutly=true);
        void generateId();
        QTreeWidgetItem* addItem();
        void select_picture();
        void edit_item(QTreeWidgetItem* , int );
        void load_deskr_editor(QTreeWidgetItem* );
        void edit_group(QTreeWidgetItem* item, const QString& prev, int column);
        void edit_manufakturer(QTreeWidgetItem* item, const QString& prev, int column);
        void preview_item(const QString& group, const QString& subgroup, const QString& item, const QString& picture, const QString& price ,const QString& description, bool b=true );
        bool get_directory();
        
private slots:
	void on_OpenBtn_clicked();
	void slot_click_rem(void);
	void slot_generate(void);
	void slot_find(void);
        void slot_edit_item( QTreeWidgetItem * item, int column );
        void slot_currentItemChanged ( QTreeWidgetItem * current, QTreeWidgetItem * previous );
public:
	void find_codec(void);
protected:
  virtual void keyReleaseEvent( QKeyEvent * event );
private slots:
    void slot_save_as();
signals:
    void emit_msg(const QString& );
};

#endif // DF_H
